#include <bits/stdc++.h>
using namespace std;
bool cmp(pair<int,int> a,pair<int,int> b){
    return a.second < b.second;
}
int main(){
    int n,q,k;
    cin >> n >> q >> k;
    vector<int> a;
    for(int i=0;i<n;i++){
        int x;cin >> x;
        a.push_back(x);
    }
    vector<pair<int,int> > b;
    for(int i=0;i<n;i++){
        b.push_back({i+1,i+1});
    }
    while(q--){
        int l,r;
        cin >> l >> r;
        l--;
        int j=0;
        int i=l;
        while(i<=r-1){
        	b[i].second=a[j];
        	i++;
        	j++;
		}
        sort(b.begin()+l,b.begin()+r,&cmp);
    }
    cout << b[k-1].first;
}
